
Smart Proxy - Bug #1759

Certifcate Signing fails in the UI with latest HEAD

07/17/2012 11:00 AM - Greg Sutcliffe

Status: Closed   

Priority: Urgent   

Assignee: Ohad Levy   

Category: Puppet   

Target version: 1.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

Steps to reproduce:

Build New VM

Git clone Foreman

bundle install --path vendor/

db:migrate (I used sqlite3 for speed)

start foreman

install foreman-proxy & sudo setup for certificate signing

Add proxy to foreman's proxy page

create new unsigned cert:

rm -rf /var/lib/puppet/

puppet master -v  &

puppet agent --server `hostname -f` --certname unsigned-thing

Foreman -> Smart Proxies -> Certificates -> Click 'sign' by 'unsigned-thing'

Should fail

Related issues:

Has duplicate Foreman - Bug #1766: puppetca proxy broken with puppet 2.7.18 Duplicate 07/18/2012

Associated revisions

Revision ffbd0e7d - 07/18/2012 03:41 AM - Ohad Levy

fixes #1759 - puppet 2.7.18 changed puppetca output

which result in adding quotes to the certnames.

this patch should cover both cases (older and newer puppet)

History

#1 - 07/17/2012 11:04 AM - Ohad Levy

- Target version set to 1.0

#2 - 07/18/2012 02:39 AM - Ohad Levy

this looks like an issue with puppet 2.7.18 where the certnames are now qouated.

if anyone could try the following patch and let me know:

diff --git a/lib/proxy/puppetca.rb b/lib/proxy/puppetca.rb

index 0f44fe7..e33adc0 100644

--- a/lib/proxy/puppetca.rb

+++ b/lib/proxy/puppetca.rb

@@ -132,10 +132,10 @@ module Proxy::PuppetCA

     # parse the puppetca --list output

     def certificate str
       case str

-        when /(\+|\-)\s+(.*)\s+\((\S+)\)/

+        when /(\+|\-)\s+["]{0,1}(.*\w)["]{0,1}\s+\((\S+)\)/

           state = $1 == "-" ? "revoked" : "valid" 

           return { $2.strip =&gt; { :state =&gt; state, :fingerprint =&gt; $3 } }

-        when /(.*)\s+\((\S+)\)/

+        when /\s*["]{0,1}(.*\w)["]{0,1}\s+\((\S+)\)/

           return { $1.strip =&gt; { :state =&gt; "pending", :fingerprint =&gt; $2 } }

         else

           return {}

#3 - 07/18/2012 02:45 AM - Ohad Levy

- Project changed from Foreman to Smart Proxy

- Target version deleted (1.0)

#4 - 07/18/2012 02:45 AM - Ohad Levy

- Category set to Puppet

#5 - 07/18/2012 03:43 AM - Ohad Levy

- Target version set to 1.0

#6 - 07/18/2012 03:50 AM - Ohad Levy

- Status changed from New to Closed

- % Done changed from 0 to 100

Applied in changeset ffbd0e7d4c39e2ec40b321abf955edfae04d2dd3.
